<template>
    <el-row :gutter="20" id="auth" type="flex" justify="center" align="middle">
        <el-col :lg="6" :md="6" :sm="24" align="middle">
            <div class="auth-container" v-loading="loading">
                <img :src="require('../../assets/logo-pusri.png')" :width="200">
                <el-form v-if="authStatus === 'login'" ref="loginForm" :model="loginForm" :rules="loginRules" class="auth-form" auto-complete="off" label-position="top" status-icon @submit.prevent="doLogin">
                    <div class="auth-text">
                        <h2>Welcome to Doctrin!</h2>
                        <small>Enter your phone number to login. We'll send you an OTP to your registered mobile phone.</small>
                    </div>
                    <el-alert v-if="isFailed" v-bind:title="failMessageTitle" v-bind:description="failMessage" type="error" :closable="false" center></el-alert>
                    <el-form-item prop="identity">
                        <el-input
                            ref="identity"
                            name="identity"
                            v-model="loginForm.identity"
                            placeholder="08123456789"
                            auto-complete="off"
                            prefix-icon="el-icon-mobile-phone"
                            type="number">
                        </el-input>
                    </el-form-item>
                    <el-form-item>
                        <el-button class="margin-small-top" type="primary" native-type="submit" @click.native.prevent="doLogin">Log me in!</el-button>
                    </el-form-item>
                </el-form>
                <el-form v-if="authStatus === 'verify'" ref="verifyForm" :model="verifyForm" :rules="verifyRules" class="auth-form" auto-complete="off" label-position="top" status-icon @submit.prevent="doVerify">
                    <div class="auth-text">
                        <h2>Verify it was you!</h2>
                        <small>Enter 6 digits OTP sent to your mobile phone.</small>
                    </div>
                    <el-alert v-if="isFailed" v-bind:title="failMessageTitle" v-bind:description="failMessage" type="error" :closable="false"></el-alert>
                    <el-form-item prop="passkey">
                        <el-input 
                            ref="passkey"
                            name="passkey"
                            v-model="verifyForm.passkey"
                            prefix-icon="el-icon-mobile-phone"
                            auto-complete="off"
                            :maxlength="6"
                            :minlength="6"
                            class="text-uppercase"
                            placeholder="●●●●●●">
                            <template slot="append">
                                <strong>
                                    <countdown ref="countdown" v-if="counting" :time="300000" :transform="transform" @end="handleCountdownEnd">
                                        <template slot-scope="props">{{ props.minutes }} : {{ props.seconds }}</template>
                                    </countdown>
                                    <span v-else>00:00</span>
                                </strong>
                            </template>
                        </el-input>                        
                    </el-form-item>
                    <el-form-item>
                        <el-button type="primary" native-type="submit" @click.native.prevent="doVerify">Yes, it was me!</el-button>
                        <el-button type="text" native-type="button" :disabled="counting" @click.native.prevent="doReverify">Resend OTP</el-button>
                    </el-form-item>
                </el-form>
            </div>
        </el-col>        
    </el-row>
</template>

<script>

import { mapGetters } from 'vuex';

export default {
    name: 'Login',
    data() {

        return {
            loginForm: {
                identity: ''
            },
            loginRules: {
                identity: [{ 
                    required: true, message: 'Phone number is required', trigger: 'blur'
                }, {
                    pattern: /\(?(?:\+628|628|08)(?:\d{2,3})?\)?[ .-]?\d{2,4}[ .-]?\d{2,4}[ .-]?\d{2,4}/, 
                    message:'Invalid phone number', 
                    trigger: 'blur'
                }],
            },
            verifyForm: {
                passkey: ''
            },
            verifyRules: {
                passkey: [{ required: true, message: 'OTP is required', trigger: 'blur' }]
            },
            loading: false,
            redirect: undefined,
            counting: false
        }
    },
    watch: {
        $route: {
            handler: function(route){
                this.redirect = route.query && route.query.redirect;
            },
            immediate: true
        }
    },
    computed: {
        ...mapGetters('auth', [
            'authStatus',
            'isFailed',
            'failMessageTitle',
            'failMessage',
            'verificationCode'
        ])
    },
    mounted() {
        if(this.loginForm.phone === ''){
            this.$refs.phone.focus();
        }
    },
    methods: {
        transform(props) {
            Object.entries(props).forEach(([key, value]) => {
                const digits = value < 10 ? `0${value}` : value;
                props[key] = `${digits}`;
            });
            return props;
        },
        handleCountdownEnd(){
            this.counting = false;
        },
        doLogin() {
            this.$refs.loginForm.validate(valid => {
                if (valid) {
                    this.loading = true;
                    this.$store.dispatch('auth/doLogin', {
                        identity: this.loginForm.identity,
                        access: 'dashboard'
                    }).then((response) => {
                        this.loading = false;
                        if(response !== undefined){
                            if('verification_code' in response){
                                this.counting = true;
                            }else{
                                this.$router.push({ path: this.redirect || '/' });
                            }
                        }
                    });
                } else {
                    return false;
                }
            });
        },
        doVerify() {
            this.$refs.verifyForm.validate(valid => {
                if(valid){
                    this.loading = true;
                    this.$store.dispatch('auth/doVerify', {
                        passkey: this.verifyForm.passkey,
                        code: this.$store.state.auth.verificationCode.code
                    }).then(() => {
                        this.loading = false;
                        this.$router.push({ path: this.redirect || '/' });
                    });
                }else{
                    return false;
                }
            });
        },
        doReverify() {
            this.loading = true;
            this.$store.dispatch('auth/doReverify', {
                code: this.$store.state.auth.verificationCode.code
            }).then(() => {
                this.loading = false;
                this.counting = true;
            });
        }
    }
}
</script>
